import java.awt.*;
import java.applet.*;
public class vectorTest
{
    /*________________________________
    ___________Variable_____________*/
    pigFunc pig;
    vectorFunc v;
    vector a,
           b,
           c,
           d,
           r,
           center;
    
    vector point,
           p1,
           p2;

    /*________________________________
    ___________Initialisation_______*/
    public void initialize() 
    {
        pig = new pigFunc();
        v = new vectorFunc();
        //System.out.println("vector d: " + d.x + "," + d.y);
        
        a = new vector(50,110);
        b = new vector(200,110);
        c = new vector(200,260);
        d = new vector(50,260);
        r = v.fromRadian(0.02);
        center = new vector(125,185);
        
        point = new vector(250,160);
        
        p1 = new vector(25,210);
        p2 = new vector(125,285);
    }
    /*________________________________
    ___________Main Loop____________*/
    public void loop()
    {
        a = v.add(center,v.rotate(v.sub(a,center),r));
        b = v.add(center,v.rotate(v.sub(b,center),r));
        c = v.add(center,v.rotate(v.sub(c,center),r));
        d = v.add(center,v.rotate(v.sub(d,center),r));
    }
    
    /*________________________________
    ___________draw_________________*/
    public void paint (Graphics g) 
    {
        //draw something
        g.setColor(Color.black);
        g.drawLine(0,60,100,60);
        g.drawString("vector Test",102,64);
        
        //draw rotating box
        g.setColor(Color.red);
        pig.line(g,a,b);
        g.setColor(Color.black);
        pig.text(g,"A",a);
        g.setColor(Color.blue);
        pig.line(g,b,c);
        g.setColor(Color.black);
        pig.text(g,"B",b);
        g.setColor(Color.green);
        pig.line(g,c,d);
        g.setColor(Color.black);
        pig.text(g,"C",c);
        g.setColor(Color.orange);
        pig.line(g,d,a);
        g.setColor(Color.black);
        pig.text(g,"D",d);
        
        //draw center
        g.setColor(Color.black);
        pig.point(g,center);
        g.setColor(Color.black);
        pig.text(g,"center",center);
        
        //draw point for closest test
        g.setColor(Color.blue);
        pig.point(g,point);
        g.setColor(Color.black);
        pig.text(g,"point",point);
        
        //draw line for intersect test
        g.setColor(Color.cyan);
        pig.line(g,p1,p2);
        g.setColor(Color.black);
        pig.text(g,"p1",p1);
        pig.text(g,"p2",p2);
        
        //closest point test
        float u = v.closestU(point,a,b);
        if (u > 0 && u < 1)        //black if the point is really on the line , gray otherwise
        {
            g.setColor(Color.black);
        }
        else
        {
            g.setColor(Color.gray);
        }
        vector closest = v.closest(point,a,b, u);
        pig.point(g,closest);
        pig.text(g,"closest to point in line A B",closest); 
        pig.line(g,closest,point);      //show the perpendicularity of the closest point
        
        //intersect
        float pZero = v.parallelZero(p1,p2,b,c);
        if (pZero != 0)             //no intersection if line are parallel
        {
            float Ua = v.intersectUa(p1,p2,b,c,pZero);
            float Ub = v.intersectUb(p1,p2,b,c,pZero);
            if ((Ua < 0 || Ua > 1) && (Ub < 0 || Ub > 1))   //do line really intersect between their point
            {
                g.setColor(Color.gray);
            }
            else
            {
                g.setColor(Color.black);
            }
            vector intersect = v.intersect(p1,p2, Ua);
            pig.point(g,intersect);
            pig.text(g,"intersect B C with P1 P2",intersect);
        }
        

    }
}
