public class atomFunc{
    static vectorFunc v;
    
    public atomFunc()
    {
        v = new vectorFunc();
    }
    
    public static atom accel(atom a, vector accel)
    {
        atom b = new atom(a);
        b.vel = v.add(b.vel,accel);
        return b;
    }
    
    public static atom force(atom a, vector force)
    {
        return accel(a,v.scale(force,1.0/a.mass));
    }
    
    public static atom stop(atom a)
    {
        atom b = new atom(a);
        b.vel = new vector(0,0);
        return b;
    }
    
    public static atom move(atom a)
    {
        atom b = new atom(a);
        b.pos = v.add(a.pos,a.vel);
        return b;
    }
};
